#include<stdio.h>
#include<stdlib.h>
#include<math.h>

void scan(int N, double* a, double* b) {
  b[0] = 0;
  for (int i = 1; i < N; i++) {
    b[i] = b[i-1] + a[i-1];
  }
}

void scan_parallel(int N, double* a, double* b) {
  b[0] = 0;
  for (int i = 1; i < N; i++) {
    b[i] = b[i-1] + a[i-1];
  }
}

int main(int argc, char **argv) {
  int N = atoi(argv[1]);
  double* a = malloc(N * sizeof(double));
  double* b0 = malloc(N * sizeof(double));
  double* b1 = malloc(N * sizeof(double));
  for (int i = 0; i < N; i++)
    a[i] = rand() * 1.0 / RAND_MAX;
  scan(N, a, b0);
  scan_parallel(N, a, b1);
  double delta = 0;
  for (int i = 0; i < N; i++)
    delta += fabs(b0[i] - b1[i]);
  printf("%f\n", delta);
  free(a); free(b0); free(b1);
}
